package Pastel::String;
use Pastel::Mixin::Mixin;

@ISA = qw( Pastel::Mixin::Mixin);

use strict;

sub new
{
    my $arg = shift;
    my $class = ref($arg) || $arg;
    my $self = {};

    bless $self, $class;
    $self->_init(@_);
   
    return $self;

}

sub _init {
    my ($self, @args) = @_;

    my $string = $args[0];
    my $xml_string = $self->xml($string);
    $self->{xml_string} = $xml_string;
    return $self;
}

sub xml {
    my ($self, $arg) = @_;
    my $xml = "";
    #Split the string data into characters
    my (@characters) = split( //, $arg);

    for( my $i = 0; $i < @characters; $i++){

	if ( $characters[$i] eq '<' ){
	    $xml .= "&lt;";
	}

	elsif ( $characters[$i] eq '>' ){
	    $xml .= "&gt;" ;
	}

	elsif( $characters[$i] eq '&' ) {
	    $xml .= "&amp;" ;
	}

	elsif ( $self->get_code($characters[$i]) > 126 ){
	    $xml .= "&x";
	    $xml .= $self->get_hex( $self->get_code($characters[$i]) );
	    $xml .= ';' ;
        }

	else {
	    $xml .= $characters[$i];
	 }

    }

     return $xml;
}

sub get_code {

    my ($self, $char) = @_;
    return ord($char);
}

sub get_hex {
    my ($self, $code ) = @_;
    return unpack("H2", pack("C", $code) );
}

sub set_font {
    my ( $self, $font ) = @_;
    $self->{font} = $font;
}

sub get_font {
    my $self = shift;
    if ( defined( $self->{font} ) ) {
	return $self->{font};
    }
    else {
	return undef;
    }
}

sub get_xml_string {
    my $self = shift;
    if ( defined ( $self->{xml_string} ) ){
	return $self->{xml_string};
    } else {
	return undef;
    }
}

1;
    
